package nl.harmwal.hypercube;

import java.applet.*;
import java.net.*;
import java.lang.reflect.*;

public class Audio{

    // The sounds are from gnome-audio-2.0.0
    //
    // http://ftp.acc.umu.se/pub/GNOME/sources/gnome-audio/2.0/
    //
    // I don't know who created these sounds, but there shouldn't be
    // any licensing issues.
    //
    // Converted from wav to au with:
    // sox infile.wav -r 8012 -U -b outfile.au

    static AudioClip bump;
    static AudioClip kick;
    static AudioClip bounce;
    static AudioClip pass;
    static AudioClip gotcha;
    static AudioClip hit;
    static AudioClip gameover;

    static void init(Applet applet) {

	String bumpString = "sounds/info.au";
	String kickString = "sounds/clicked.au";
	String bounceString = "sounds/toggled.au";
	String passString = "sounds/activate.au";
	String gotchaString = "sounds/warning.au";
	String hitString = "sounds/email.au";
	String gameoverString = "sounds/shutdown1.au";

	URL url;

	try{
	    if (applet != null) {
		
		url = applet.getCodeBase();

		bump = applet.getAudioClip(url, bumpString);
		kick = applet.getAudioClip(url, kickString);
		bounce = applet.getAudioClip(url, bounceString);
		pass = applet.getAudioClip(url, passString);
		gotcha = applet.getAudioClip(url, gotchaString);
		hit = applet.getAudioClip(url, hitString);
		gameover = applet.getAudioClip(url, gameoverString);
		
	    }else{
		
		// Java 1.1 supports getAudioClip for applets, but not newAudioClip.
		// By using reflection, we don't break 1.1 compilers.
		
		Class cls = Class.forName("java.applet.Applet");
		Class partypes[] = new Class[1];
		partypes[0] = Class.forName("java.net.URL");
		Method method = cls.getMethod("newAudioClip", partypes);
		Object[] arglist = new Object[1];

		url = new URL(new String("file:" + bumpString));
		arglist[0] = (Object)url;
		bump = (AudioClip)method.invoke(new Applet(), arglist);

		url = new URL(new String("file:" + kickString));
		arglist[0] = (Object)url;
		kick = (AudioClip)method.invoke(new Applet(), arglist);


		url = new URL(new String("file:" + bounceString));
		arglist[0] = (Object)url;
		bounce = (AudioClip)method.invoke(new Applet(), arglist);


 		url = new URL(new String("file:" + passString));
		arglist[0] = (Object)url;
		pass = (AudioClip)method.invoke(new Applet(), arglist);

		url = new URL(new String("file:" + gotchaString));
		arglist[0] = (Object)url;
		gotcha = (AudioClip)method.invoke(new Applet(), arglist);

		url = new URL(new String("file:" + hitString));
		arglist[0] = (Object)url;
		hit = (AudioClip)method.invoke(new Applet(), arglist);

		url = new URL(new String("file:" + gameoverString));
		arglist[0] = (Object)url;
		gameover = (AudioClip)method.invoke(new Applet(), arglist);

	    }
	}catch(Exception e){
	    e.printStackTrace();
	}
    }
}
